<?php

require_once 'base/GepPautareuniaoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  robertomartins
 */
class GepPautareuniaoEntity extends GepPautareuniaoEntityBase
{


    /**
     * Gera novo c?o de Pauta de reuni?
     *
     * @param integer $nrorg N?o da Organiza?.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroPautareuniao($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_PAUTAREUNIAO', 10);
        return $codigo;
    }


    /**
     * Consulta o maior valor de ordena? entre os textos da pauta de reuni?
     *
     * @param integer $nrorg   N?o da Organiza?.
     * @param integer $reuniao N?o da Reuni?
     *
     * @return multitype:|boolean
     */
    public static function consultaMaiorValorOrdenacaoPauta($nrorg, $reuniao){
           $ordenacao = GepPautareuniao::consultaMaiorValorOrdenacaoPauta($nrorg, $reuniao);
           return $ordenacao;
    }


    /**
     * Retorna dados da pauta por reuni?
     *
     * @param integer $reuniao N?o da reuni?
     * @param integer $nrorg   N?o da organiza?.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaPautasByReuniao($reuniao ,$nrorg) {
        $pautareuniao = GepPautareuniao::consultaPautaByReuniao($reuniao, $nrorg);
        return $pautareuniao;
    }


    /**
     * Insere Pauta da Reuniao.
     *
     * @param integer  $nrpautareuniao N?o da Pauta de reuni?
     * @param integer  $nrorg          N?o da organiza?.
     * @param integer  $nrreuniao      N?o da reuni?
     * @param integer  $nrordenapauta  N?o da ordena?.
     * @param string   $dsgrupopauta   Grupo da Pauta.
     * @param string   $dstitulopauta  T?lo da Pauta.
     * @param string   $txpauta        Texto da Pauta.
     * @param string   $dsobservpauta  Obseva? da Pauta.
     * @param dateTime $dtinclusao     Data de inclus?
     * @param string   $cdoperinclusao C?o do operador inclus?
     * @param integer  $nrorginclusao  N?o da organiza? inclusora.
     * @param dateTime $dtultatu       Data de atualiza?.
     * @param integer  $cdoperultatu   C?o do operador ultatu.
     * @param string   $nrorgultatu    N?o da organiza? ultatu.
     *
     * @return boolean
     */
    public static function incluiPauta(
        $nrpautareuniao, $nrorg, $nrreuniao,
        $nrordenapauta, $dsgrupopauta, $dstitulopauta,
        $txpauta, $dsobservpauta, $dtinclusao,
        $cdoperinclusao, $nrorginclusao, $dtultatu,
        $cdoperultatu, $nrorgultatu
    ){
        try {
            $pauta = new self();
            $pauta->setNrpautareuniao($nrpautareuniao);
            $pauta->setNrorg($nrorg);
            $pauta->setNrreuniao($nrreuniao);
            $pauta->setNrordenapauta($nrordenapauta);
            $pauta->setDsgrupopauta($dsgrupopauta);
            $pauta->setDstitulopauta($dstitulopauta);
            $pauta->setTxpauta($txpauta);
            $pauta->setDsobservpauta($dsobservpauta);
            $pauta->setDtinclusao($dtinclusao);
            $pauta->setCdoperinclusao($cdoperinclusao);
            $pauta->setNrorginclusao($nrorginclusao);
            $pauta->setDtultatu($dtultatu);
            $pauta->setIdativo('S');
            $pauta->setCdoperultatu($cdoperultatu);
            $pauta->setNrorgultatu($nrorgultatu);
            $pauta->persist();

            return true;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }

    }


}