function sup05100_analise_AF_Controller(ScreenService, MessageService, templateManager, maskEngine, ZhUtil, General, sup05100_analise_AF_Service, Utilities, ZHPromise) {
    
    const serviceAnalise = sup05100_analise_AF_Service;
    let params;
    
    this.onEnterOnceWidgetPrincipal = function(args) {
        const wdgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        serviceAnalise.retornaParaSupriCentralCompras(getLocalVar('CDFILIAL')).then(function(parametros){
            params = parametros.dataset.parasupri_central_compras[0];
            
            if(params) {
                if(!!wdgetPrincipal.NRSEQAPUR) {
            
                    const dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": params.CDFILIAL
                        },
                        {
                            "name": "CDCOMPRADOR",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "SITUACAO",
                            "operator": "=",
                            "value": "1"
                        },
                        {
                            "name": "CDOPERADOR",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTINIPERIODO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTFINPERIODO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTGERACAO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": getLocalVar('NRORG')
                        },
                        {
                            "name": "NRAPURPREC",
                            "operator": "=",
                            "value": wdgetPrincipal.NRSEQAPUR
                        }
                    ];
        
                    wdgetPrincipal.getField('NRAPURPREC').dataSource.filter(dataSourceFilter, function(data) {
                        const { IDSITAPUPREC: situacaoApuracao } = data[0];
                        
                        wdgetPrincipal.currentRow.IDSITAPUPREC = situacaoApuracao;
                        wdgetPrincipal.currentRow.NRAPURPREC = wdgetPrincipal.NRSEQAPUR;
                        wdgetPrincipal.currentRow.CDFILLANC = wdgetPrincipal.CDFILLANC;
                        wdgetPrincipal.currentRow.CDFILCENTCMP = wdgetPrincipal.CDFILCENTCMP;
                        
                        wdgetPrincipal.currentRow.CDOPERADOR = data[0].CDOPERADOR;
                        wdgetPrincipal.currentRow.CDCOMPRADOR = data[0].CDCOMPRADOR;
                        wdgetPrincipal.currentRow.NMCOMPRADOR = data[0].NMCOMPRADOR;
                        wdgetPrincipal.currentRow.NMOPERADOR = data[0].NMOPERADOR;
                        
                        wdgetPrincipal.currentRow.DTAPURPREC = wdgetPrincipal.DTAPURPREC;
                        wdgetPrincipal.currentRow.DTINIAPUPREC = wdgetPrincipal.DTINIAPUPREC;
                        wdgetPrincipal.currentRow.DTFINAPUPREC = wdgetPrincipal.DTFINAPUPREC;
                    
                        Utilities.startFilter(wdgetPrincipal, wdgetPrincipal.currentRow);
                    });
                } else {
                	Utilities.startFilter(wdgetPrincipal);
                }
                
            } else {
                MessageService.showMessageByCode("PARASUPRI_NOT_FOUND_FILIOPER", {CDFILIAL: getLocalVar('CDFILIAL')}, Constants.errorMessage);
            }
            
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    };
    
    function exibeMensagemErro(erro) {
        MessageService.getMessageByCode("TRY_AGAIN").then( message => {
            let mensagem = message;
            
            if(erro.data) {
                mensagem = erro.data.error;
            } else if(typeof erro === 'string') {
                mensagem = erro;
            }
            
            if(erro.type !== 'click') {
                ScreenService.showMessage(mensagem);
            }
        });
    }
    
    this.limpaApuracao = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.currentRow.NRAPURPREC = "";
    };
    
    this.verificaSituacaoRequerida = function(field) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const fieldConcluida = widgetPrincipal.getField('CONCLUIDA');
        const fieldAnalise = widgetPrincipal.getField('ANALISE');
        
        if(!fieldConcluida.checked && !fieldAnalise.checked) {
            if(field.name === 'ANALISE') {
                fieldConcluida.checked = true;
                fieldConcluida.setValue('2_3_4');
            } else {
                fieldAnalise.checked = true;
                fieldAnalise.setValue('1');
            }
        }
        
        this.limpaApuracao();
    };
    
    this.getNrApuracao = function(widget) {
    	const currentRow = widget.currentRow;
        const situacao   = [currentRow.ANALISE, currentRow.CONCLUIDA].join("_");
        const apuracaoField = widget.getField("NRAPURPREC");
        
        apuracaoField.dataSourceFilter = [
			{
				'name': 'CDFILIAL',
				'operator': '=',
				'value': getLocalVar('CDFILIAL')
			},
			{
				'name': 'CDCOMPRADOR',
				'operator': '=',
				'value': currentRow.CDCOMPRADOR
			},
			{
				'name': 'SITUACAO',
				'operator': '=',
				'value': situacao
			},
			{
				'name': 'CDOPERADOR',
				'operator': '=',
				'value': getLocalVar('CDOPERADOR')
			},
			{
				'name': 'DTINIPERIODO',
				'operator': '=',
				'value': currentRow.DTPERIODO.start || ''
			},
			{
				'name': 'DTFINPERIODO',
				'operator': '=',
				'value': currentRow.DTPERIODO.end || ''
			},
			{
				'name': 'DTGERACAO',
				'operator': '=',
				'value': currentRow.DATA
			}
		];
        
        //apuracaoField.reload().then(function(callback) {
            currentRow.NRAPURPREC = "";	
        //});
    };
    
    this.filtraApuracao = function(widget) {
        var currentRow = widget.currentRow;
        var situacao   = [currentRow.ANALISE, currentRow.CONCLUIDA].join("_");
        var dataSourceFilter = [];
        currentRow.NRAPURPREC = "";
        
        dataSourceFilter = {
            'CDFILIAL': getLocalVar('CDFILIAL'),
            'CDCOMPRADOR': currentRow.CDCOMPRADOR,
            'SITUACAO': situacao,
            'CDOPERADOR': currentRow.CDOPERADOR,
            'DTINIPERIODO': currentRow.DTPERIODO.start || '',
            'DTFINPERIODO': currentRow.DTPERIODO.end || '',
            'DTGERACAO': currentRow.DATA
        };
        
        General.onClickDependentField(widget.getField("NRAPURPREC"), dataSourceFilter);
    };
    
    /**
     * A apuração atual é a que foi FILTRADA e, portanto, a que se encontra
     * na backupRow, já que essa é atualizada na função confirmarFiltro.
     * 
     * Pode ser diferente da apuração SELECIONADA, já que o usuário pode
     * selecionar uma nova apuração e não realizar o filtro, optando por clicar
     * em cancelar.
     */ 
    function getApuracaoAtual() {
        return templateManager.container.getWidget("stripeWidget").currentRow;
    }
    
    this.setDataSourceFilter = function(args) {
        const stripe = templateManager.container.getWidget('stripeWidget');
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        stripe.filteredRow = filterRow;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFILLANC",
		        "operator": "=",
		        "value": getLocalVar('CDFILIAL')
		    },
		    {
		        "name": "P_NRSEQAPURAF",
		        "operator": "=",
		        "value": filterRow.NRAPURPREC
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILDEST",
                        "direction": "ASC"
                    },
                    {
                        "name": "NMFANTFORN",
                        "direction": "ASC"
                    },
                    {
                        "name": "NRAUTOFORN",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		widget.reload().then(function(callback) {
		    const actions = widget.actions;
		    const firstRow = callback.dataset.sup05100_unidades.find(x => x!==undefined);
            
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
		    widget.activate();
		    widget.showCheckbox = firstRow ? firstRow.IDSITAPUPREC === '1' : true;
		});
		
    };
    
    function setVisibilityOfActions(actions, visibility) {
        actions.map(action => {
            action.isVisible = (action.name === 'reenviarEmail' || action.name === 'salvarRelatorioAF') ? !visibility : visibility;
        });
    }
    
    function aplicarMascara(widget, fieldName) {
        return Util.applyMask(widget.currentRow[fieldName], widget.getField(fieldName).mask, maskEngine, ZhUtil);
    }
    
    function setStripeValues() {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const stripeCurrentRow = stripeWidget.currentRow;
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(widgetPrincipal.dataSource.data.length){
            const firstRow = widgetPrincipal.dataSource.data[0];
            
            stripeCurrentRow.NRAPURPREC = firstRow.NRAPURPREC;
            stripeCurrentRow.VRTOTALAPURAC = firstRow.VRTOTALAPURAC;
            stripeCurrentRow.DESCCOMPRADOR = firstRow.CDCOMPRADOR.concat(' | ', firstRow.NMOPERADOR);
            stripeCurrentRow.PERIODO = moment(firstRow.DTINIAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY').concat(' | ', moment(firstRow.DTFINAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY'));
            stripeCurrentRow.IDSITAPUPREC = firstRow.IDSITAPUPREC;
            stripeCurrentRow.DSSITAPUPREC = stripeWidget.getField('DSSITAPUPREC').options[firstRow.IDSITAPUPREC];
            stripeCurrentRow.CDCOMPRADOR = firstRow.CDCOMPRADOR;
            stripeCurrentRow.NMCOMPRADOR = firstRow.NMCOMPRADOR;
            stripeCurrentRow.CDOPERADOR = firstRow.CDOPERADOR;
            stripeCurrentRow.NMOPERADOR = firstRow.NMOPERADOR;
            stripeCurrentRow.DTAPURPREC = firstRow.DTAPURPREC;
            stripeCurrentRow.DTINIAPUPREC = moment(firstRow.DTINIAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY');
            stripeCurrentRow.DTFINAPUPREC = moment(firstRow.DTFINAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY');
            stripeCurrentRow.CDFILLANC = firstRow.CDFILLANC;
            stripeCurrentRow.CDFILCENTCMP = firstRow.CDFILCENTCMP;
            
            stripeCurrentRow.VRTOTALAPURAC = aplicarMascara(stripeWidget, 'VRTOTALAPURAC');
        } else {
            stripeCurrentRow.NRAPURPREC = "";
            stripeCurrentRow.VRTOTALAPURAC = "";
            stripeCurrentRow.NMCOMPRADOR = "";
            stripeCurrentRow.PERIODO = "";
            stripeCurrentRow.IDSITAPUPREC = "";
            stripeCurrentRow.CDCOMPRADOR = "";
            stripeCurrentRow.DTAPURPREC = "";
            stripeCurrentRow.DTINIAPUPREC = "";
            stripeCurrentRow.DTFINAPUPREC = "";
            stripeCurrentRow.CDFILLANC = "";
            stripeCurrentRow.CDFILCENTCMP = "";
        }
    }
    
    this.abreProdutos = function(widget) {
        const tabbed      = widget.container.getWidget("tabbed");
        const produtos    = widget.container.getWidget("produtos");
        
        produtos.dataSource.clearCheckedRows();
        
        produtos.dataSourceFilter = [
            { 'name': 'P_CDFILDEST',   'operator': '=', 'value': widget.currentRow.CDFILDEST   },
			{ 'name': 'P_CDFILLANC',   'operator': '=', 'value': widget.currentRow.CDFILLANC   },
			{ 'name': 'P_NRSEQAPURAF', 'operator': '=', 'value': widget.currentRow.NRAPURPREC  },
			{ 'name': 'P_NRAUTOFORN',  'operator': '=', 'value': widget.currentRow.NRAUTOFORN  },
			{ 'name': 'P_DTPROGENTAF', 'operator': '=', 'value': widget.currentRow.DTPROGENTAF }
		];
		produtos.reload();
		ScreenService.openSwipe(tabbed);
    };
    
    this.voltarAtivar = function(widget) {
        ScreenService.closeSwipe();
        widget.activate();
    };
    
    this.editarProduto = function() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        
        if (isApuracaoConcluida()) {
            MessageService.showMessageByCode("ANALISE_ALREADY_FINISHED", null, Constants.errorMessage);
        } else {
            General.widgetEdit(widgetProduto);
        }
    };
    
    function isApuracaoConcluida() {
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        
        return (stripeWidget.currentRow && stripeWidget.currentRow.IDSITAPUPREC != '1');
    }
    
    this.salvaEdicaoProduto = function(isDataEntregaValida) {
        const widgetProduto = templateManager.container.getWidget('produtos');
        
        if(widgetProduto.isValid()) {
            if(!isDataEntregaValida) {
                validaDataEntrega();
            } else {
                confirmSaveProduct();
            }
        }
    };
    
    function confirmAtuDeEntrSoli(row) {
        const deferred = ZHPromise.defer();
        
        if(moment(row.DTPROGENTAF_OLD, 'DD/MM/YYYY').format('DD/MM/YYYY') !== moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')) {
            return MessageService.confirmMessageByCode("UPDATE_DTPROGENTAF_AF_ITEMSOLI", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function confirmSaveProduct() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const currentRowProduto = widgetProduto.currentRow;
        
        confirmaQuantidade(converteParaFloat(currentRowProduto.QTPROGENTAF)).then(function() {
            currentRowProduto.IDGERAFDTENT = widgetPrincipal.currentRow.IDGERAFDTENT;
            currentRowProduto.CDFORNECED = widgetPrincipal.currentRow.CDFORNECED;
            currentRowProduto.IDFUNCAOFILI = widgetPrincipal.currentRow.IDFUNCAOFILI;
            currentRowProduto.DTPROGENTAF_OLD = widgetProduto.backupRow.DTPROGENTAF;
            currentRowProduto.QTPROGENTAF_OLD = widgetProduto.backupRow.QTPROGENTAF;
            currentRowProduto.ALTERADTENTREGA = currentRowProduto.ALTERADTENTREGA ? currentRowProduto.ALTERADTENTREGA : false;
            
            MessageService.confirmMessageByCode("UPDATE_SOLICITA", null, Constants.confirmationMessage).then(() => {
                confirmAtuDeEntrSoli(currentRowProduto).then(function() {
                    currentRowProduto.ATUSOLICITACMP = true;
                    serviceAnalise.salvaEdicaoProduto(currentRowProduto).then(function(mensagem) {
                        finalizaEdicao(widgetPrincipal, widgetProduto, mensagem);
                    }).catch(function(erro) {
                        exibeMensagemErro(erro);
                    });
                }.bind(this));
            }, function(error) {
                currentRowProduto.ATUSOLICITACMP = false;
                serviceAnalise.salvaEdicaoProduto(currentRowProduto).then(function(mensagem) {
                    finalizaEdicao(widgetPrincipal, widgetProduto, mensagem);
                }).catch(function(erro) {
                    exibeMensagemErro(erro);
                });
            });
        });
    }
    
    function validaDataEntrega() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const dtprogentafAntiga = widgetProduto.backupRow.DTPROGENTAF.substring(0, 10);
        const dtprogentafAntigaMoment = moment(dtprogentafAntiga, 'DD/MM/YYYY');
        const dtprogentafNova = widgetProduto.currentRow.DTPROGENTAF.substring(0, 10);
        const dtprogentafNovaMoment = moment(dtprogentafNova, 'DD/MM/YYYY');
        const dataAtual = moment(moment().format('DD/MM/YYYY'), 'DD/MM/YYYY');
        
        if(dtprogentafAntiga != dtprogentafNova) {
            if(dtprogentafNovaMoment < dataAtual) {
                MessageService.showMessageByCode("DTPROGENTAF>DTATUAL", null, Constants.alertMessage);
            } else {
                confirmaValidade(dtprogentafNovaMoment, dtprogentafAntigaMoment).then(function() {
                    confirmaAfPorDataEntrega();
                }.bind(this));
            }
        } else {
            confirmSaveProduct();
        }
    }
    
    function confirmaValidade(dtprogentafNova, dtprogentafAntiga) {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const nrDiasValidade = converteParaFloat(widgetProduto.currentRow.NRDIASVALPRFORN);
        const deferred = ZHPromise.defer();
        
        if(nrDiasValidade) {
            const diferencaDias = Math.abs(dtprogentafNova.diff(dtprogentafAntiga, 'days'));
            
            if(diferencaDias > nrDiasValidade) {
                return MessageService.confirmMessageByCode("CONFIRM_VALIDADE_DIAS", null, Constants.confirmationMessage);
            } else {
                deferred.resolve();
            }
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function confirmaAfPorDataEntrega() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetProduto = templateManager.container.getWidget('produtos');
        const idgerafdtent = widgetPrincipal.currentRow.IDGERAFDTENT;
        
        widgetProduto.currentRow.ALTERADTENTREGA = false;
        
        if(idgerafdtent === 'S') {
            MessageService.confirmMessageByCode("QUESTION_AF_DTPROGENTR", null, Constants.confirmationMessage).then(() => {
                widgetProduto.currentRow.ALTERADTENTREGA = true;
                confirmSaveProduct();
            }, function(error) {
                widgetProduto.currentRow.ALTERADTENTREGA = false;
                MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF", null, Constants.alertMessage);
            });
        } else {
            confirmSaveProduct();
        }
    }
    
    function confirmaQuantidade(quantidade) {
        var deferred = ZHPromise.defer();
        
        if(quantidade == 0) {
            return MessageService.confirmMessageByCode("QTPROGENTAF_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function converteParaFloat(valor) {
        if(valor) {
            if(typeof valor === 'string') {
                valor = valor.replace(/\./g, '').replace(',', '.');
            }
            
            valor = parseFloat(valor);
        }
        
        return valor;
    }
    
    function finalizaEdicao(widgetAf, widgetProduto, mensagem) {
        var excluido = mensagem.messages[0].message;

        if(excluido.EDITED_ITEM) {
        	ScreenService.closeSwipe().then(function() {
				ScreenService.closeSwipe().then(function() {
					MessageService.successNotificationByCode('SUCCESS_OPERATION');
					widgetAf.activate();
					widgetAf.reload();
				});
        	});
        } else if(!excluido.AF_DELETADA && !excluido.ITEM_DELETADO) {
            ScreenService.closeSwipe().then(function() {
                widgetProduto.activate();
                widgetProduto.reload();
            });
        } else if(excluido.AF_DELETADA) {
            ScreenService.closeSwipe(0).then(function() {
                MessageService.successNotificationByCode('ITEMAUTF_AND_AF_DELETED');
                widgetAf.activate();
                widgetAf.reload();
            });
        } else if(excluido.ITEM_DELETADO) {
            ScreenService.closeSwipe().then(function() {
                MessageService.successNotificationByCode('ITEMAUTF_DELETED');
                widgetProduto.activate();
                widgetProduto.reload();
            });
        }
    }
    
    this.clearApuracao = function(field) {
        field.widget.getField('NRAPURPREC').clearValue();
        field.widget.getField('NMFILIAL').clearValue();
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearUnidadeDestino = function(field) {
        field.widget.getField('NMFILIAL').clearValue();
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearFornecedor = function(field) {
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearAF = function(field) {
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    function setPopUpValues(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        
        const fieldComprador = widget.getField('NMCOMPRADOR');
        const fieldApuracao = widget.getField('NRAPURPREC');
        const firstRow = widgetPrincipal.dataSource.data.find(x=>x!==undefined);
        
        setReadOnlyFields(widget, false, allFieldsExceptComprador);
		
        fieldApuracao.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeWidget.currentRow.CDFILLANC    },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeWidget.currentRow.CDFILCENTCMP }
        ];
        
        fieldApuracao.reload().then(function(){
            fieldComprador.setValue(stripeWidget.currentRow.NMOPERADOR);
        	fieldApuracao.setValue([stripeWidget.currentRow.NRAPURPREC]);
    		widget.currentRow.CDCOMPRADOR = firstRow.CDCOMPRADOR;
    		widget.currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;
    
            widget.getField('NMFANTFORN').clearValue();
            widget.getField('NMFILIAL').clearValue();
            widget.getField('NRAUTOFORN').clearValue();
    
    		ScreenService.openPopup(widget);
        });
    }
    
    this.excluirAF = function(widget) {
        if (widget.hasCheckedRows()) {
            MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
                const row = getRowForExclusaoAF();
                
                serviceAnalise.excluirAF(row).then(function(success) {
                    finalizaExclusaoAF(success);
                }).catch(function(error) {
                    exibeMensagemErro(error);
                });
            });
        } else {
            setPopUpValues(templateManager.container.getWidget('exclusaoAfsEmAnalise'));
        }
    };
    
    function filtraApuracaoAF(widget) {
    	const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;

        widget.getField("NRAPURPREC").dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeRow.CDFILLANC         },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeRow.CDFILCENTCMP         }
        ];
        widget.getField("NRAPURPREC").reload();
    }
    
    function filtraAF(widget) {
        const row         = angular.copy(widget.currentRow);
        const CDCOMPRADOR = row.CDCOMPRADOR || null;
        const APURACAO    = concatArrayForParams(row.NRAPURPREC);
        const CDFORNECED  = concatArrayForParams(row.NMFANTFORN);
        const CDFILIAL    = concatArrayForParams(row.NMFILIAL);
        
        widget.getField('NRAUTOFORN').dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': CDCOMPRADOR  },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': APURACAO     },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': CDFORNECED   },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': CDFILIAL	  }
        ];
        
        widget.getField('NRAUTOFORN').reload();
    }
    
    this.setDataSourceComprador = function(field) {
    	const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const comprador = Array.isArray(row.CDCOMPRADOR) ? concatArrayForParams(row.CDCOMPRADOR) : row.CDCOMPRADOR;
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': comprador },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': apuracao  },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(row.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(row.NMFILIAL)	  }
        ];
        
        field.reload();
    };
    
    this.setDataSourceFilterFornecedor = function(field) {
        const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDFILLANC',	'operator': '=', 'value': row.CDFILLANC },
            {  'name': 'P_NRSEQAPURAF',	'operator': '=', 'value': apuracao },
            {  'name': 'P_CDFILDEST',	'operator': '=', 'value': concatArrayForParams(row.NMFILIAL) },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "IDTPIJURFORN",
                        "direction": "ASC"
                    },
                    {
                        "name": "NRINSJURFORN",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        
        field.reload();
    };
    
    this.setDataSourceFilterAF = function(field) {
    	const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': row.CDCOMPRADOR },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': apuracao  },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(row.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(row.NMFILIAL)	  }
        ];
        
        field.reload();
    };
    
    function allFieldsExceptComprador(field) {
        return field.name !== 'NMCOMPRADOR';
    }
    
    this.validaApuracao = function(args, field) {
        const widget = templateManager.container.getActiveWidget();
        const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeRow.CDFILLANC         },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeRow.CDFILCENTCMP         }
        ];
        
        field.reload().then(function() {
            if(field.dataSource.data.length == 0) {
                args.e.preventDefault();
                MessageService.showMessageByCode("APURPRECO_NOT_REGISTERED", null, Constants.errorMessage);
            } 
        });
    };
    
    function setReadOnlyFields(widget, readOnlyValue, filterFunction) {
        const fields = filterFunction ? widget.fields.filter(filterFunction) : widget.fields;
        
        fields.map(field => { field.readOnly = readOnlyValue; });
    }
    
    function finalizaExclusaoAF(response) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.reload().then(function(callback) {
            ScreenService.closePopup(true);
            MessageService.successNotificationByCode('SUCCESS_DELETE');
            if (callback.dataset.sup05100_unidades.length){
                widgetPrincipal.dataSource.clearCheckedRows();
            	widgetPrincipal.activate();
            } else {
                widgetPrincipal.currentRow.NRAPURPREC = '';
                
                setStripeValues();
                
                Utilities.startFilter(widgetPrincipal, widgetPrincipal.currentRow);
            }
        });
    }
    
    function getRowForExclusaoAF() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = widgetPrincipal.getCheckedRows();
        
        if (Util.isEmptyOrBlank(afsSelecionadas)) {
            const currentRowExclusaoAfs = templateManager.container.getWidget('exclusaoAfsEmAnalise').currentRow;
            
            return {
                AFS_SELECIONADAS: null,
                P_AUTOFORNE: !Util.isEmptyOrBlank(currentRowExclusaoAfs.CONC_AUTOFORNE) ? currentRowExclusaoAfs.CONC_AUTOFORNE : 'T',
                P_NRAPURPREC: concatArrayForParams(currentRowExclusaoAfs.NRAPURPREC),
                P_CDFORNECED: concatArrayForParams(currentRowExclusaoAfs.NMFANTFORN),
                P_CDFILIAL: concatArrayForParams(currentRowExclusaoAfs.NMFILIAL),
                P_CDCOMPRADOR: currentRowExclusaoAfs.CDCOMPRADOR || null
            };
        } else {
            const apuracaoAtual = getApuracaoAtual();
            
            return {
                AFS_SELECIONADAS: afsSelecionadas,
                P_IDQTFRACIONADO: apuracaoAtual.IDQTFRACIONADO,
                P_NRAPURPREC: apuracaoAtual.NRAPURPREC, // widgetPrincipal.currentRow.NRAPURPREC
            };
        }
    }
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    this.voltarParaWidgetPrincipal = function() {
        ScreenService.closePopup();
    };
    
    this.onChangeCompradorExclusao = function() {
        const widget = templateManager.container.getWidget('exclusaoAfsEmAnalise');
        const fieldComprador = widget.getField('NMCOMPRADOR');
        
        clearFieldsWidget('exclusaoAfsEmAnalise', allFieldsExceptComprador);
        
        if (!Util.isEmptyOrBlank(fieldComprador.value())) {
            filtraApuracaoAF(widget);
            filtraAF(widget);
        }
    };
    
    function clearFieldsWidget(widgetName, filterFunction) {
        const widget = templateManager.container.getWidget(widgetName);
        const fields = filterFunction ? widget.fields.filter(filterFunction) : widget.fields;
        
        fields.map(field => { field.clearValue(); });
    }
    
    this.confirmarExclusaoAF = function() {
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
            const row = getRowForExclusaoAF();
            
            serviceAnalise.excluirAF(row).then(function(success) {
                finalizaExclusaoAF(success);
            }).catch(function(error) {
                exibeMensagemErro(error);
            });
        });
    };
    
    this.liberarAF = function(widget) {
        if (widget.hasCheckedRows()) {
            const apuracao = getApuracaoAtual();
            
            abreEscolhaGerenteDoComprador(apuracao.CDCOMPRADOR);
        } else {
            setPopUpValues(templateManager.container.getWidget('liberarAfsInconsistentes'));
        }
    };
    
    function abreEscolhaGerenteDoComprador(codigoComprador) {
        const widgetGerenteDoComprador = templateManager.container.getWidget('gerenteComprador');
        const fieldGerenteDoComprador = widgetGerenteDoComprador.getField('NMGERENTE');
        
        fieldGerenteDoComprador.dataSourceFilter = [
            {  'name': 'CDOPERGERE',        'operator': '=',    'value': 'T'                                },
            {  'name': 'CDOPERCOMP',        'operator': '=',    'value': codigoComprador                    },
            {  'name': 'NRORG',             'operator': '=',    "value": getLocalVar('NRORG')               }
        ];
        fieldGerenteDoComprador.reload();
        
        ScreenService.openPopup(widgetGerenteDoComprador);
    }
    
    this.confirmarLiberacaoAF = function() {
        const widgetLiberarInconsistencias = templateManager.container.getWidget('liberarAfsInconsistentes');
        
        if (widgetLiberarInconsistencias.isValid()) {
            serviceAnalise.validarBeforeLiberarAF(widgetLiberarInconsistencias.currentRow).then(function() {
                MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
                    abreEscolhaGerenteDoComprador(widgetLiberarInconsistencias.currentRow.CDCOMPRADOR);
                });
            }).catch(function(erro) {
                exibeMensagemErro(erro);
            });
        }
    };
    
    this.onChangeComprador = function() {
        const widgetLiberarInconsistencias = templateManager.container.getWidget('liberarAfsInconsistentes');
        const fieldComprador = widgetLiberarInconsistencias.getField('NMCOMPRADOR');
        
        clearFieldsWidget('liberarAfsInconsistentes', allFieldsExceptComprador);
        
        if (!Util.isEmptyOrBlank(fieldComprador.value())) {
            compradorPossuiGerentes(widgetLiberarInconsistencias).then(function() {
                setReadOnlyFields(widgetLiberarInconsistencias, false, allFieldsExceptComprador);
                filtraApuracaoAF(widgetLiberarInconsistencias);
                filtraAF(widgetLiberarInconsistencias);
            }.bind(this), function(erro) {
                setReadOnlyFields(widgetLiberarInconsistencias, true, allFieldsExceptComprador);
                
                fieldComprador.clearValue();
                widgetLiberarInconsistencias.currentRow.CDCOMPRADOR = '';
                
                exibeMensagemErro(erro);
            });
        } else {
            setReadOnlyFields(widgetLiberarInconsistencias, true, allFieldsExceptComprador);
        }
    };
    
    function compradorPossuiGerentes(widget) {
        return serviceAnalise.verificarGerenteComprador(widget.currentRow);
    }
    
    this.validaAF = function(args, field) {
        const widget = templateManager.container.getActiveWidget();
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': concatArrayForParams(widget.currentRow.NRAPURPREC) },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(widget.currentRow.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(widget.currentRow.NMFILIAL)	  }
        ];
        
        field.reload().then(function() {
            if(field.dataSource.data.length === 0) {
                args.e.preventDefault();
                MessageService.showMessageByCode("NAO_HA_AF_INCONSISTENTE", null, Constants.errorMessage);
            } 
        });
    };
    
    this.voltarEscolhaGerenteDoComprador = function() {
        const widget = templateManager.container.getActiveWidget();
        
        clearFieldsWidget('gerenteComprador');
        ScreenService.closePopup();
        
        widget.activate();
    };
    
    this.confirmarEscolhaGerenteDoComprador = function() {
        const widgetGerenteComprador = templateManager.container.getWidget('gerenteComprador');
        
        if (widgetGerenteComprador.isValid()) {
            const currentRowGerenteComprador = widgetGerenteComprador.currentRow;
            
            serviceAnalise.validarSenhaGerente(currentRowGerenteComprador).then(function(response) {
                const row = getRowForLiberacaoAF();
                
                widgetGerenteComprador.currentRow = {};
                
                serviceAnalise.liberarAFInconsistente(row).then(function(success) {
                    const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
                    
                    widgetPrincipal.reload().then(function() {
                        ScreenService.closePopup(true);
                        
                        widgetPrincipal.dataSource.clearCheckedRows();
                        widgetPrincipal.activate();
                        
                        if (success.messages) {
                            ScreenService.showMessage(success.messages[0].message);
                        }
                        
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                    });
                });
            }).catch(function(erro) {
                exibeMensagemErro(erro);
                currentRowGerenteComprador.PASSWORD = "";
            });
        }
    };
    
    function getRowForLiberacaoAF() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = widgetPrincipal.getCheckedRows();
        const currentRowGerenteComprador = templateManager.container.getWidget('gerenteComprador').currentRow;
        
        if (Util.isEmptyOrBlank(afsSelecionadas)) {
            const currentRowLiberacaoAfs = templateManager.container.getWidget('liberarAfsInconsistentes').currentRow;
            
            return {
                AFS_SELECIONADAS: null,
                P_AUTOFORNE: !Util.isEmptyOrBlank(currentRowLiberacaoAfs.CONC_AUTOFORNE) ? currentRowLiberacaoAfs.CONC_AUTOFORNE : 'T', // Utilizado apenas para o Liberar AF's pela widget 'liberarAfsInconsistentes'
                P_NRAPURPREC: concatArrayForParams(currentRowLiberacaoAfs.NRAPURPREC),
                P_CDFORNECED: concatArrayForParams(currentRowLiberacaoAfs.NMFANTFORN),
                P_CDFILIAL: concatArrayForParams(currentRowLiberacaoAfs.NMFILIAL),
                P_CDCOMPRADOR: currentRowLiberacaoAfs.CDCOMPRADOR,
                P_CDGERENTE: currentRowGerenteComprador.CDGERENTE
            };
        } else {
            const apuracaoAtual = getApuracaoAtual();
            
            return {
                IDSITAPUPREC: apuracaoAtual.IDSITAPUPREC,
                AFS_SELECIONADAS: afsSelecionadas,
                P_NRAPURPREC: widgetPrincipal.currentRow.NRAPURPREC, 
                P_CDGERENTE: currentRowGerenteComprador.CDGERENTE
            };
        }
    }
    
    this.concluirAnalise = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(widgetPrincipal.hasCheckedRows()) {
            openPopUpConcluirAnalise(true);
        } else {
            openPopUpConcluirAnalise(false);
        }
    };
    
    function openPopUpConcluirAnalise(hasCheckedRows) {
        const popupWidget = templateManager.container.getWidget('popupConcluirAnalise');
        
        serviceAnalise.retornaCookieEmail({}).then(function(success) {
            popupWidget.getField('ASSUNTO').setValue(success.messages[0].message);
            popupWidget.getField('MENSAGEM').setValue(success.messages[1].message);
            
            popupWidget.getField('REPORT_NAME').setValue('padraoEnvioAF.BIRT');
            popupWidget.getField('QR2TYPE').setValue('PDF');
            popupWidget.getField('enviarEmailAF').setValue('S');
            popupWidget.getField('CLASSE').setValue('N');
            
            popupWidget.currentRow.EMITIR_AF = 'N';

            popupWidget.getField('NMFANTFORN').isVisible = !hasCheckedRows;
            popupWidget.getField('NMFILIAL').isVisible = !hasCheckedRows;
            popupWidget.getField('NRAUTOFORN').isVisible = !hasCheckedRows;
            
            setFilterFields(popupWidget);
            
            ScreenService.openPopup(popupWidget);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function finalizaConclusoaAnalise(success) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        const afInconsist = success.messages.length ? success.messages[0].message.AF_INCONSIST : false;
        
        if(afInconsist) {
            MessageService.showMessageByCode("INCONSISTENT_NRAPURPREC", {NRAPURPREC: success.messages[0].message.NEW_NRAPURPREC}, Constants.errorMessage);
        } else {
            MessageService.successNotificationByCode('SUCCESS_OPERATION');
        }
        
        ScreenService.closePopup(true);
        widgetPrincipal.reload().then(function(callback){
            const firstRow = callback.dataset.sup05100_unidades.find(x => x!==undefined);
            
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.showCheckbox = firstRow ? firstRow.IDSITAPUPREC === '1' : true;
            widgetPrincipal.getField('NRAPURPREC').reload();
            widgetPrincipal.unSelectAll();
            widgetPrincipal.reload();
            widgetPrincipal.activate();
            exibeLogEnviosAF(success);
        });
    }
    
    function concluirAF() {
        serviceAnalise.concluirAF(getRowForConclusaoAnalise()).then(function(success) {
            finalizaConclusoaAnalise(success);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function salvarRelatorioDeAf() {
        const popupAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        MessageService.confirmMessageByCode("VIEW_REPORT", null, Constants.confirmationMessage).then(function(success) {
            popupAnalise.currentRow.EMITIR_AF = 'S';
            concluirAF();
        }, function (error) {
            popupAnalise.currentRow.EMITIR_AF = 'N';
            concluirAF();   
        });
    }
    
    this.confirmarConclusaoAnalise = function() {
        const popUpAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        if(popUpAnalise.getField('enviarEmailAF').checked){
            popUpAnalise.currentRow.EMITIR_AF = 'N';
            
            serviceAnalise.defineCookieEmail(popUpAnalise.currentRow).then(function(success) {
                return serviceAnalise.concluirAF(getRowForConclusaoAnalise()).then(function(success) {
                    finalizaConclusoaAnalise(success);
                });
            }).catch(function(error) {
                exibeMensagemErro(error);
            });
        } else {
            salvarRelatorioDeAf();
        }
    };
    
    this.setVisibilityOfClasse = function(widget) {
        const field = widget.getField('CLASSE');
        
        field.isVisible = widget.getField('enviarEmailAF').checked ? true : false;
    };
    
    function getRowForConclusaoAnalise() {
        const currentRowConclusaoAnalise = templateManager.container.getWidget('popupConcluirAnalise').currentRow;
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetPopUpSelect = templateManager.container.getWidget('popupConcluirAnalise');
        
        return {
            "ALL_DATA_APURACAO": widgetPrincipal.dataSource.data,
            "CURRENT_ROW": widgetPopUpSelect.currentRow,
            "DADOS_APURACAO": getApuracaoAtual(),
            "AFS_SELECIONADAS": widgetPrincipal.getCheckedRows(),
            "CLASSE": currentRowConclusaoAnalise.CLASSE ? currentRowConclusaoAnalise.CLASSE : 'N',
            "DADOS_RELATORIO": {
                "NOME_RELATORIO": currentRowConclusaoAnalise.REPORT_NAME,
                "EXTENSAO": currentRowConclusaoAnalise.QR2TYPE,
                "CLASSE": currentRowConclusaoAnalise.CLASSE,
                "EMITIR_AF": currentRowConclusaoAnalise.EMITIR_AF,
                "EMAIL_AF": currentRowConclusaoAnalise.enviarEmailAF.checked
            },
            "DADOS_EMAIL": {
                "ASSUNTO": currentRowConclusaoAnalise.ASSUNTO,
                "MENSAGEM": Utilities.changeTagRichText(currentRowConclusaoAnalise.MENSAGEM),
            }
        };
    }
    
    function exibeLogEnviosAF(success) {
        const logSucesso = success.messages[0].message.SUCESSO;
        const logErro = success.messages[0].message.ERRO;
        const widgetOrigem = templateManager.container.getActiveWidget();
        let popupConcluirAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        if (!Util.isEmptyOrBlank(logSucesso)) {
            if(popupConcluirAnalise.currentRow.EMITIR_AF === 'S'){
                openRelatorio(logSucesso[0]);       
            } else {
                adicionaCabecalhoAoLog(logSucesso, 'Sucesso');
            }
        }
    
        if (!Util.isEmptyOrBlank(logErro)) {
            adicionaCabecalhoAoLog(logErro, 'Erro');
        }
        
        if(popupConcluirAnalise.currentRow.enviarEmailAF === 'S'){
            showLogMessages(widgetOrigem, logErro, logSucesso);
        } else {
            if (!Util.isEmptyOrBlank(logErro)) {
                showLogMessages(widgetOrigem, logErro, logSucesso);
            }
        }
    }
    
    function openRelatorio(url) {
        let popup_window = window.open(url, '_blank');
        
        if (!popup_window) {
            ScreenService.showMessage('Pop-up Blocker is enabled! Please add this site to your exception list.');
        }
    }
    
    function adicionaCabecalhoAoLog(logArray, titulo) {
        logArray.unshift('----------------------------');
        logArray.unshift(titulo);
        logArray.unshift('----------------------------');
    }
    
    function showLogMessages(widgetOrigem, logErro, logSucesso) {
        let mensagem = logErro.concat(logSucesso);
        
        General.showErrorMessages(widgetOrigem, mensagem, ScreenService.i18n('Log'));
    }
    
    this.abreInformacao = function(widgetInformacao) {
        var currentRowProduto = widgetInformacao.container.getWidget('produtos').currentRow;
        var idmotprescaf = currentRowProduto.IDMOTPRESCAF;
        var idtipolanitm = currentRowProduto.IDTIPOLANITM;
        var nrcotpreitaf = currentRowProduto.NRCOTPREITAF ? currentRowProduto.NRCOTPREITAF : '';
        var nrlistaitaf = currentRowProduto.NRLISTAITAF ? currentRowProduto.NRLISTAITAF : '';
        var indexMensagem = '';
        var mensagem = '';
        
        for(var i = 0; i < idmotprescaf.length; i++) {
            indexMensagem = i + idmotprescaf[i];
            mensagem = mensagem + mensagensInformacao(indexMensagem);
        }
        
        if(!mensagem) {
            mensagem = mensagem + mensagensInformacao('M0');
        }
        
        mensagem = mensagem + mensagensInformacao('M1', nrcotpreitaf) + mensagensInformacao('M2', nrlistaitaf);
        
        if(idtipolanitm === 'M') {
            mensagem = mensagem + mensagensInformacao('M3');
        }

        widgetInformacao.currentRow.mensagem = mensagem;
        
        ScreenService.openPopup(widgetInformacao);
    };
    
    function mensagensInformacao(indexMensagem, param) {
        var mensagens = {
            '01': 'Escolhido por Produto Preferencial.\n',
            '17': 'Escolhido por Fornecedor/Marca Obrigatórios.\n',
            '18': 'Escolhido por Fornecedor/Marca Preferenciais.\n',
            '19': 'Escolhido por Fornecedor/Marca Restritivos.\n',
            '24': 'Escolhido por Fornecedor Obrigatório.\n',
            '25': 'Escolhido por Fornecedor Preferencial.\n',
            '26': 'Escolhido por Fornecedor Restritivo.\n',
            '2A': 'Escolhido por Acordo.\n',
            '31': 'Escolhido por Marca Obrigatória.\n',
            '32': 'Escolhido por Marca Preferencial.\n',
            '33': 'Escolhido por Marca Restritiva.\n',
            '41': 'Escolhido da Lista de Preços.\n',
            '42': 'Escolhido da Cotação Fora da Lista.\n',
            '51': 'Apuração para solicitações extras - Fornecedor escolhido não é extra.\n',
            '52': 'Apuração para solicitações extras - Fornecedor escolhido é extra.\n',
            '53': 'Apuração para solicitações não extras.\n',
            'M0': 'Escolhida manualmente.\n',
            'M1': 'Cotação: ' + param + '\n',
            'M2': 'Lista de preços: ' + param + '\n',
            'M3': 'Obs.: Item alterado manualmente.\n'
        };
        
        return mensagens[indexMensagem] ? mensagens[indexMensagem] : '';
    }
    
    this.abreSituacao = function(widgetSituacao) {
        var currentRowProdutos = widgetSituacao.container.getWidget('produtos').currentRow;
        var currentRowAF = widgetSituacao.container.getWidget('widgetPrincipal').currentRow;
        var currentRowStripe = widgetSituacao.container.getWidget('stripeWidget').currentRow;
        
        var dtprogentaf = moment(currentRowProdutos.DTPROGENTAF, 'DD/MM/YYYY');
        var dtPeriodoIni = moment(currentRowStripe.PERIODO.substring(0, 10), 'DD/MM/YYYY');
        var dtPeriodoFin = moment(currentRowStripe.PERIODO.substring(13), 'DD/MM/YYYY');
        var dtProcessamento = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        var dtAtual = moment();
        var mensagemSituacao = '';
        var mensagemValidacao = '';
        
        if(dtprogentaf < dtAtual.format('DD/MM/YYYY')) {
            mensagemSituacao = 'Data de entrega menor que a data atual.\n';
        } else if(currentRowProdutos.DTPROGENTAF === dtAtual.format('DD/MM/YYYY')) {
            mensagemSituacao = 'Data de entrega igual a data atual.\n';
        }
        
        if(currentRowAF.DSINCONSAF) {
            mensagemSituacao = mensagemSituacao + currentRowAF.DSINCONSAF + '\n';
        }
        
        if(currentRowProdutos.DSINCONSITAF) {
            mensagemSituacao = mensagemSituacao + currentRowProdutos.DSINCONSITAF + '\n';
        }
        
        if(dtprogentaf >= dtProcessamento) {
            if(dtprogentaf < dtPeriodoIni || dtprogentaf > dtPeriodoFin) {
                mensagemSituacao = mensagemSituacao + 'Data de entrega fora do período de apuração.\n';
            }
        }
        
        widgetSituacao.currentRow.mensagemSituacao = mensagemSituacao;
        
        mensagemValidacao = constroiErrosValidacao(currentRowProdutos.CDPRODUTO + currentRowProdutos.CDMARCA);
        
        if(mensagemValidacao) {
            widgetSituacao.getField('mensagemValidacao').isVisible = true;
            widgetSituacao.currentRow.mensagemValidacao = mensagemValidacao;
        } else {
            widgetSituacao.getField('mensagemValidacao').isVisible = false;
        }
        
        ScreenService.openPopup(widgetSituacao);
    };
    
    function constroiErrosValidacao(widgetProduto, prodMarca) {
        var erros = {};
        var mensagemValidacao = '';
        
        if(erros.length) {
            if(erros[prodMarca][0] === 'S') {
                mensagemValidacao = 'Produto não qualificado para o fornecedor da AF informada. \n';
            }
            
            if(erros[prodMarca][1] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Fornecedor da AF informada não possui preço para o produto ou não atende as particularidades do produto na filial. \n';
            }
            
            if(erros[prodMarca][2] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Produto não cadastrado para o fornecedor da AF informada. \n';
            }
            
            if(erros[prodMarca][3] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Não é permitido remanejar item de AF não atendido pelo fornecedor logístico obrigatório, para uma AF com status OL. \n';
            }   
        }
        
        return mensagemValidacao;
    }
    
    /*Remanejamento*/
    
    this.remanejarAF = function(widget = templateManager.container.getActiveWidget(), trocaProd = false) {
        const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;
        const afsSelecionadas = retornaAFsParaRemanejar();
        
        verificaConfirmarRemanejoAF().then(function() {
            return verificaTodasAFsSelecionadas(afsSelecionadas, stripeRow);
        }).then(function() {
        	const cdfildest = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        	abreEscolhaAF(afsSelecionadas, widget, trocaProd, cdfildest, stripeRow.CDFILLANC, stripeRow.NRAPURPREC);
        }).catch(function(erro) {
            exibeMensagemErro(erro);
        });
    };
    
    function verificaConfirmarRemanejoAF() {
        const deferred = ZHPromise.defer();
        
        if(params.IDCONFREMANEJAF === 'N') {
            return MessageService.confirmMessageByCode("CONFIRM_REMANEJAMENTO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();  
        }
        
        return deferred.promise;
    }
    
    function verificaTodasAFsSelecionadas(afsSelecionadas, stripeRow) {
        const deferred = ZHPromise.defer();
        const cdfildest = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        
        serviceAnalise.retornaCountAF(cdfildest, stripeRow.CDFILLANC, stripeRow.NRAPURPREC).then(function(callback) {
            const quantidadeAF = callback.dataset.sup05100_afs_count.length ? callback.dataset.sup05100_afs_count[0].QUANTIDADE_AFS : null;
            
            if(afsSelecionadas.length === parseFloat(quantidadeAF)) {
                return MessageService.showMessageByCode("ALL_SELECTED_AF", {CDFILDEST: cdfildest}, Constants.alertMessage);
            } else {
                deferred.resolve();
            }
        });
        
        return deferred.promise;
    }
    
    function abreEscolhaAF(afsSelecionadas, widgetAtiva, trocaProd, cdfildest, cdfillanc, nrseqapuraf) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetRemanejo = widgetAtiva.container.getWidget("remanejo");
        const fieldNrautoforn = widgetRemanejo.getField("NRAUTOFORN");
        const principalData = angular.copy(widgetPrincipal.dataSource.data);
        const allRows = principalData.filter(function(afs) {
            return afs.CDFILDEST === cdfildest[0] && afs.CDFILLANC === cdfillanc && afs.NRAPURPREC === nrseqapuraf && !afs.__isSelected;
        });
        
        fieldNrautoforn.dataSource.data = allRows;
        widgetRemanejo.WIDGET_PAI = widgetAtiva.name;
        widgetRemanejo.TROCA_PROD = trocaProd;
        ScreenService.openPopup(widgetRemanejo).then(function() {
            widgetRemanejo.applyDefaultValue();
        });
    }
    
    this.beforeSelectPrincipalRow = function(args) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const activeWidget = templateManager.container.getActiveWidget();
        
        if(widgetPrincipal !== activeWidget) {
            ScreenService.closePopup(true);
            ScreenService.closeSwipe();
            widgetPrincipal.activate();
        }
    };
    
    this.verifyDifferentUnidades = function(args) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = retornaAFsParaRemanejar();
        const uniqueRows = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        
        setVisibilityOfRemanejarAFActions(widgetPrincipal, uniqueRows.length == 1);
    };
    
    function getActionsByName(widget, namesToFind) {
        return widget.actions.filter(action => { return namesToFind.includes(action.name); });
    }
    
    this.enableRemanejo = function(widget) {
        setVisibilityOfRemanejarAFActions(widget, true);
    };
    
    function setVisibilityOfRemanejarAFActions(widget, isVisible) {
        const actionsToFind = [
            'remanejarAF',
            'remanejarAFItens',
            'remanejarAFItensRelacionados',
            'remanejarProdAF',
            'remanejarTrocarProduto'
        ];
        const actions = getActionsByName(widget, actionsToFind);
        
        isVisible = isVisible && !isApuracaoConcluida();
        setVisibilityOfActions(actions, isVisible);
    }
    
    function retornaAFsParaRemanejar() {
        const activeWidget = templateManager.container.getActiveWidget();
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        let afsSelecionadas;
        
        if (activeWidget.name === 'actions_widget') {
            afsSelecionadas = widgetPrincipal.getCheckedRows();
            
            if (Util.isEmptyOrBlank(afsSelecionadas)) {
                afsSelecionadas = [widgetPrincipal.currentRow];
            }
        } else {
            afsSelecionadas = widgetPrincipal.getCheckedRows();
        }
        
        return afsSelecionadas;
    }
    
    this.confirmarRemanejoAF = function(widgetRemanejo) {
        if(widgetRemanejo.isValid()) {
            const afsSelecionadas = retornaAFsParaRemanejar();
            const afDestino = widgetRemanejo.currentRow;
            const validacaoBlocoAFs = validaBlocoAFs(afsSelecionadas, afDestino);
            const currentRowRemanejo = widgetRemanejo.currentRow;
            const apuracaoAtual = getApuracaoAtual();
            
            exibeMensagemConfirmacao(validacaoBlocoAFs.AF_INCONS).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.GERA_DTENTREGA);
            }).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.PRORROGAR_DT);
            }).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.VALIDADE);
            }).then(function() {
                if(widgetRemanejo.TROCA_PROD) {
                    const prodSelecionados = widgetRemanejo.container.getWidget('produtos').getCheckedRows()[0];
                    abreEscolhaProduto(widgetRemanejo, afDestino, prodSelecionados);
                } else {
                	if(widgetRemanejo.WIDGET_PAI === 'produtos') {
                	    const prodSelecionados = widgetRemanejo.container.getWidget('produtos').getCheckedRows();
                	    
                	    serviceAnalise.remanejarItensAF(prodSelecionados, afDestino, currentRowRemanejo, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
							const messageRemanejo = callback.messages ? callback.messages[0].message : null;
							
							finalizaRemanejamento(messageRemanejo);
						}, function(error) {
							exibeMensagemErroRemanejamento(error);
						});
                	} else {
						serviceAnalise.remanejarAF(afsSelecionadas, afDestino, currentRowRemanejo, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
							const messageRemanejo = callback.messages ? callback.messages[0].message : null;
							
                            finalizaRemanejamento(messageRemanejo);
						}, function(error) {
							exibeMensagemErroRemanejamento(error);
						});
                    }
                }
            }).catch(function(erro) {
                exibeMensagemErro(erro);
            });
        }
    };
    
    function showErrorsRemanejamento(selected_rows) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        let promises = [];
        
    	promises.push(MessageService.getMessageByCode("PRODUCTS_WITHOUT_PRICE"));
    	promises.push(MessageService.getMessageByCode("DISQUALIFIED_PRODUCT"));
    	promises.push(MessageService.getMessageByCode("PRODUCTS_N_REGISTERED_SUPPLIER"));
    	
    	Promise.all(promises).then((messages) => {
            let arrayMesssages = [];
            let arrayError = [];
            	
            if(messages[0]) arrayMesssages.PRODUCTS_WITHOUT_PRICE = messages[0];
            if(messages[1]) arrayMesssages.DISQUALIFIED_PRODUCT = messages[1]; 
            if(messages[2]) arrayMesssages.PRODUCTS_N_REGISTERED_SUPPLIER = messages[2];

            selected_rows.forEach(function(row) {
        		let messageFunction;
            	
            	if(row.P_RESULT_ERROS === 'NNN') {
            	    return MessageService.successNotificationByCode('SUCCESS_OPERATION');
            	}
        		
        		arrayError = setHeader(arrayError, row);
                        
                row.PRODUCTS.forEach(function(product) {
                    if(product.ERROR.substr(0, 1) === 'S') {
						messageFunction = replaceMessage(arrayMesssages.DISQUALIFIED_PRODUCT, product);
						arrayError = arrayError.concat(messageFunction);
					} 
					if(product.ERROR.substr(1, 1) === 'S') {
						messageFunction = replaceMessage(arrayMesssages.PRODUCTS_WITHOUT_PRICE, product);
						arrayError = arrayError.concat(messageFunction);
					} 
					if(product.ERROR.substr(2, 1) === 'S') {
					    messageFunction = replaceMessage(arrayMesssages.PRODUCTS_N_REGISTERED_SUPPLIER, product);
					    arrayError = arrayError.concat(messageFunction);
					}
                });
            });
            
            if(arrayError.length){
                General.showErrorMessages(widgetOrigem, arrayError, ScreenService.i18n('Log'));
            }
    	});
    }
    
    function setHeader(arrayError, row) {
    	let title_array = [];
    	
    	if(!arrayError.includes(row.NRAUTOFORN.concat(' | ', moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')))) {
    		title_array.unshift('----------------------------');
            title_array.unshift(row.NRAUTOFORN.concat(' | ', moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')));
            title_array.unshift('----------------------------');
    	}
    	
    	return arrayError.concat(title_array);
    }
    
    function replaceMessage(message, row) {
        return message.replace('__NMFANTFORN__', row.NMFANTFORN).replace('__CDARVPROD__', row.CDARVPROD);
    }
    
    function exibeMensagemErroRemanejamento(error) {
        var widgetProdutos = templateManager.container.getWidget('produtos');
        
        if(error.data) {
            if(error.data.errorCode == 100) {
                widgetProdutos.ERROS_REMANEJAMENTO = error.data.error;
                MessageService.showMessageByCode("INVALID_REMANEIO");
                finalizaRemanejamento();
            } else if(error.data.errorCode == 200) {
                widgetProdutos.ERROS_REMANEJAMENTO = error.data.error;
                ScreenService.showMessage(error.data.error);
                finalizaRemanejamento();
            } else {
                exibeMensagemErro(error);
            }
        }
    }
    
    function finalizaRemanejamento(messages) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        
        ScreenService.closePopup(true);
        ScreenService.closeSwipe();
        widgetPrincipal.reload().then(function() {
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.unSelectAll();
            widgetPrincipal.activate();
            if(messages){
                showErrorsRemanejamento(messages);	
            }
        });
    }
    
    function abreEscolhaProduto(widget, afDestino, prodSelecionados) {
        var widgetEscolhaProd = widget.container.getWidget('remanejoTrocaProd');
        var fieldProduto = widgetEscolhaProd.getField('NMPRODUTO');
        var dtprogentaf = moment(prodSelecionados.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
        
        fieldProduto.dataSourceFilter = [
            { 'name': 'CDPRODESTO',     'operator': '=',    'value': prodSelecionados.CDPRODESTO        },
            { 'name': 'CDPRODUTO',      'operator': '=',    'value': prodSelecionados.CDPRODUTO         },
            { 'name': 'CDFORNECED',     'operator': '=',    'value': afDestino.CDFORNECED               },
            { 'name': 'CDFILDEST',      'operator': '=',    'value': prodSelecionados.CDFILDEST         },
            { 'name': 'DTPROGENTAF',    'operator': '=',    'value': dtprogentaf                        },
            { 'name': 'IDMOTIVPRESC',   'operator': '=',    'value': prodSelecionados.IDMOTPRESCAF      },
            { 'name': 'CONSPARTFILDEST','operator': '=',    'value': widget.currentRow.CONSPARTFILDEST  },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    },
                    {
                        "name": "VRPRECUNIITM",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        
        fieldProduto.reload().then(function(produtos) {
            produtos = produtos.dataset.sup05100_produtos_itemcole_particularidades ? produtos.dataset.sup05100_produtos_itemcole_particularidades[0] : produtos.dataset.sup05100_produtos_itemcole[0];

            if(produtos) {
                ScreenService.openPopup(widgetEscolhaProd).then(function() {
                    widgetEscolhaProd.applyDefaultValue();
                });
            } else {
                exibeMensagemErro('Não há produtos de mesmo grupo de estoque cotados para o fornecedor da AF de destino ou o mesmo não atende as particularidades do produto na filial.');
            }
        });
    }
    
    function exibeMensagemConfirmacao(mensagem) {
        var deferred = ZHPromise.defer();
        
        if(mensagem) {
            return ScreenService.confirmMessage(mensagem, "question");
        } else {
            deferred.resolve();  
        }

        return deferred.promise;
    }
    
    function validaBlocoAFs(afsSelecionadas, afDestino) {
        const dtprogentafDestinoMoment = moment(afDestino.DTPROGENTAF, 'DD/MM/YYYY');
        const validacaoBlocoAFs = {
            'AF_INCONS': false,
            'GERA_DTENTREGA': false,
            'PRORROGAR_DT': false,
            'VALIDADE': false
        };
        
        afsSelecionadas.forEach(function(af) {
            const dtprogentafOrigemMoment = moment(af.DTPROGENTAF, 'DD/MM/YYYY');
            const nrDiasValidade = converteParaFloat(af.MIN_PRODVALIDADE);
            
            validacaoBlocoAFs.AF_INCONS = !validacaoBlocoAFs.AF_INCONS ? validaAFInconsistente(af.IDSITUATUAAF, af.IDAFFORALIM) : validacaoBlocoAFs.AF_INCONS;
            validacaoBlocoAFs.GERA_DTENTREGA = !validacaoBlocoAFs.GERA_DTENTREGA ? validaDtentregaRemanejamento(afDestino.IDGERAFDTENT, dtprogentafOrigemMoment, dtprogentafDestinoMoment) : validacaoBlocoAFs.GERA_DTENTREGA;
            validacaoBlocoAFs.PRORROGAR_DT = !validacaoBlocoAFs.PRORROGAR_DT ? validaProrrogaDtentrega(dtprogentafOrigemMoment, dtprogentafDestinoMoment) : validacaoBlocoAFs.PRORROGAR_DT;
            validacaoBlocoAFs.VALIDADE = !validacaoBlocoAFs.VALIDADE ? validaValidadeProduto(nrDiasValidade, dtprogentafDestinoMoment, dtprogentafOrigemMoment) : validacaoBlocoAFs.VALIDADE;
        });

        return validacaoBlocoAFs;
    }
    
    
    function validaAFInconsistente(idsituatuaaf, idafforalim) {
        if(!idsituatuaaf && idafforalim === 'N') {
            return "AF não está inconsistente. <br> Deseja continuar?";
        } else {
            return false;
        }
    }
    
    function validaDtentregaRemanejamento(idgerafdtent, dtprogentafOrigem, dtprogentafDestino) {
        if(idgerafdtent === 'S' && dtprogentafDestino.format('DD/MM/YYYY') != dtprogentafOrigem.format('DD/MM/YYYY')) {
            return "Fornecedor da AF destino possui entrega diferente da do Fornecedor da AF origem. <br> Entrega será alterada. <br> Deseja continuar?";
        } else {
            return false;
        }
        
    }
    
    function validaProrrogaDtentrega(dtprogentafOrigem, dtprogentafDestino) {
        if(dtprogentafOrigem < dtprogentafDestino) {
            return "Tem certeza que deseja prorrogar a entrega do produto?";
        } else {
            return false;
        }
    }
    
    
    function validaValidadeProduto(nrDiasValidade, dtprogentafNova, dtprogentafAntiga) {
        if(nrDiasValidade) {
            var diferencaDias = Math.abs(dtprogentafNova.diff(dtprogentafAntiga, 'days'));

            if(diferencaDias > nrDiasValidade) {
                return 'A "Validade (dias)" de um ou mais itens é inferior à diferença de dias entre a entrega atual e a nova data de entrega. <br> Deseja prosseguir?';
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    this.voltarAcoes = function(widget, nomeWidgetActivate) {
        ScreenService.closePopup();
        widget.container.getWidget(nomeWidgetActivate).activate();
    };
    
    this.confirmarRemanejoTrocaProd = function() {
        const widgetRemanejo = templateManager.container.getWidget('remanejo');
        const selectProduct = templateManager.container.getWidget('produtos').getCheckedRows();
    	const apuracaoAtual = getApuracaoAtual();
    	const currentRowRemanejo = widgetRemanejo.currentRow;
    	const currentRowRemanejoTrocaProd = templateManager.container.getWidget('remanejoTrocaProd').currentRow;
    	
        serviceAnalise.remanejarAFTrocaProd(currentRowRemanejo, currentRowRemanejoTrocaProd, selectProduct, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
            const messageRemanejo = callback.messages ? callback.messages[0].message : null;
            
            finalizaRemanejamento(messageRemanejo);
		}, function(error) {
			exibeMensagemErroRemanejamento(error);
		});
    };
    
    this.remanejarAFTrocaProd = function(widgetProduto) {
        const prodSelecionados = widgetProduto.getCheckedRows();
        
        if(validaQuantProdSelecionados(prodSelecionados)) {
            this.remanejarAF(widgetProduto, true);
        }
        
    };
    
    function validaQuantProdSelecionados(prodSelecionados) {
        if(prodSelecionados.length > 1) {
            exibeMensagemErro('É permitido alterar apenas um produto por vez.');
            return false;
        } else {
            return true;
        }
    }
    
    this.checkGridAF = function(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.currentRow.__isSelected = true;
        widgetPrincipal.updateCheckedRows();
    };
    
    this.uncheckGridAF = function(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(!widget.getCheckedRows().length) {
            widgetPrincipal.unSelectAll();
        }
    };
    
    this.salvarRelatorioAF = function() {
        MessageService.getMessageByCode("SALVAR_RELATORIO").then( message => {
            openPopUpReenviarEmailSalvarRelatorio(message, false);
        });
    };
    
    this.reenviarEmail = function() {
        MessageService.getMessageByCode("REENVIAR_EMAIL").then( message => {
            openPopUpReenviarEmailSalvarRelatorio(message);
        });
    };
    
    function openPopUpReenviarEmailSalvarRelatorio(label, email = true) {
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        serviceAnalise.retornaCookieEmail(popupWidget.currentRow).then(function(success) {
            popupWidget.label = label;
            popupWidget.getField('NOME_RELATORIO').setValue('padraoEnvioAF.BIRT');
            popupWidget.getField('EXTENSAO').setValue('PDF');
            
            popupWidget.getField('ASSUNTO').isVisible = email;
            popupWidget.getField('ASSUNTO').setValue(success.messages[0].message);
            popupWidget.getField('MENSAGEM').isVisible = email;
            popupWidget.getField('MENSAGEM').setValue(success.messages[1].message);
            
            popupWidget.getField('emailNaoEnviado').isVisible = email;
            popupWidget.getField('emailNaoEnviado').setValue('S');
            popupWidget.getField('emailEnviado').isVisible = email;
            popupWidget.getField('emailEnviado').setValue('S');
            
            setFilterFields(popupWidget);
            
            popupWidget.currentRow.ISRESENDEMAIL = email;
            
            ScreenService.openPopup(popupWidget);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function setFilterFields(widget) {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        
        widget.currentRow.NRAPURPREC = stripeWidget.currentRow.NRAPURPREC;
        widget.currentRow.CDCOMPRADOR = stripeWidget.currentRow.CDCOMPRADOR;
        widget.currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;

        widget.getField('NMFANTFORN').clearValue();
        widget.getField('NMFILIAL').clearValue();
        widget.getField('NRAUTOFORN').clearValue();
    }
    
    function getRowForReenvio(salvarRelatAF) {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const gridWidget = templateManager.container.getWidget('widgetPrincipal');
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        const currentRow = popupWidget.currentRow;
        
        currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;
        currentRow.NRAPURPREC = stripeWidget.currentRow.NRAPURPREC;
        currentRow.CDFILCENTCMP = stripeWidget.currentRow.CDFILCENTCMP;
        currentRow.DTINIAPUPREC = stripeWidget.currentRow.DTINIAPUPREC;
        currentRow.DTFINAPUPREC = stripeWidget.currentRow.DTFINAPUPREC;
        currentRow.IDSITAPUPREC = stripeWidget.currentRow.IDSITAPUPREC;
        currentRow.EMITIR_AF = salvarRelatAF ? 'S' : 'N';
        
        return {
            "ALL_DATA_APURACAO": gridWidget.dataSource.data,
            "CURRENT_ROW": currentRow
        };
    }
    
    function exibeLogReenvioAF(success) {
        const logSucesso = success.messages[0].message.SUCESSO;
        const logErro = success.messages[0].message.ERRO;
        const widgetOrigem = templateManager.container.getActiveWidget();
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        if (!Util.isEmptyOrBlank(logSucesso)) {
            if(popupWidget.currentRow.EMITIR_AF === 'S'){
                openRelatorio(logSucesso[0]);       
            } else {
                adicionaCabecalhoAoLog(logSucesso, 'Sucesso');
            }
        }
        
        if (!Util.isEmptyOrBlank(logErro)) {
            adicionaCabecalhoAoLog(logErro, 'Erro');
        }
        
        if(popupWidget.currentRow.ISRESENDEMAIL){
            showLogMessages(widgetOrigem, logErro, logSucesso);
        } else {
            if (!Util.isEmptyOrBlank(logErro)) {
                showLogMessages(widgetOrigem, logErro, logSucesso);
            }
        }
    }
    
    function finalizaReenvio(success) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        
        widgetPrincipal.reload().then(function(){
            ScreenService.closePopup(true);
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.getField('NRAPURPREC').reload();
            widgetPrincipal.activate();
            exibeLogReenvioAF(success);
        });
    }
    
    this.confirmaReenvioEmailRelatorio = function() {
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        if(popupWidget.currentRow.ISRESENDEMAIL) {
            if(popupWidget.currentRow.emailEnviado === 'N' && popupWidget.currentRow.emailNaoEnviado === 'N') {
                MessageService.showMessageByCode("ERROR_RESEND_NOT_CHECKED", null, Constants.errorMessage);  
            } else {
                serviceAnalise.defineCookieEmail(popupWidget.currentRow).then(function(success) {
                    return serviceAnalise.resendEmail(getRowForReenvio(false)).then(function(success) {
                        finalizaReenvio(success);
                    });
                }).catch(function(error) {
                    exibeMensagemErro(error);
                });   
            }
        } else {
            return serviceAnalise.resendEmail(getRowForReenvio(true)).then(function(success) {
                finalizaReenvio(success);
            });
        }
    };
    
    this.remanejarAFItensApuracao = function(widget, itemRelac) {
        const produtosRemaneja = templateManager.container.getWidget('popupRemanejamentoApuracao');
        let nrAutoForn = [];
    	let cdFilDest = [];
    	let cdFilLanc = [];
    	let cdProduto = [];
    	let nrApurPrec = [];
        
        ScreenService.closePopup(true);
        
        if(widget.name === 'produtos') {
            ScreenService.closeSwipe();
            
            widget.getCheckedRows().forEach(function(af) {
                nrAutoForn.push(af.NRAUTOFORN);
                cdFilDest.push(af.CDFILDEST);
                cdFilLanc.push(af.CDFILLANC);
                nrApurPrec.push(af.NRAPURPREC);
                cdProduto.push(af.CDPRODUTO);
            });
        } else {
            widget.getCheckedRows().forEach(function(af) {
                nrAutoForn.push(af.NRAUTOFORN);
                cdFilDest.push(af.CDFILDEST);
                cdFilLanc.push(af.CDFILLANC);
                nrApurPrec.push(af.NRAPURPREC);
            });
        }
        
        produtosRemaneja.dataSourceFilter = [
            {  'name': 'P_CDFILDEST',      'operator': '=',    'value': concatArrayForParams([...new Set(cdFilDest)]) },
			{  'name': 'P_CDFILLANC',      'operator': '=',    'value': concatArrayForParams([...new Set(cdFilLanc)]) },
			{  'name': 'P_NRSEQAPURAF',    'operator': '=',    'value': concatArrayForParams([...new Set(nrApurPrec)]) },
			{  'name': 'P_CDPRODUTO',      'operator': '=',    'value': concatArrayForParams([...new Set(cdProduto)]) },
			{  'name': 'P_NRAUTOFORN',     'operator': '=',    'value': concatArrayForParams([...new Set(nrAutoForn)]) },
			{  'name': 'P_ITENSRELAC',     'operator': '=',    'value': itemRelac }
		];
        
        produtosRemaneja.reload();
        
        ScreenService.openPopup(produtosRemaneja);
    };
    
    this.concluiRemanejamentoApuracao = function(){
        const widget = templateManager.container.getWidget('popupRemanejamentoApuracao');
        
        serviceAnalise.concluiRemanejamentoApuracao(widget.getCheckedRows()).then(function(mensagem) {
            console.log(1);
        }).catch(function(erro) {
            exibeMensagemErro(erro);
        });
        
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('sup05100_analise_AF_Controller', sup05100_analise_AF_Controller);
});